(function($, Drupal, window) {

  Drupal.behaviors.chaseOrbitalHpf = {
    attach: function (context, settings) {
      // Frame being viewed by user
      if (top === self) {
        window.cancelCREPayment = this.cancelCREPayment;
        window.whatCVV2 = this.whatCVV2;
        window.creHandleErrors = this.creHandleErrors;
        window.creHandleDetailErrors = this.creHandleDetailErrors;
        window.startCREPayment = this.startCREPayment;
        window.completeCREPayment = this.completeCREPayment;
      }
      else {
        // We are embedded in the hosted payment frame.
        var hpfParams = settings.commerceChase;

        if (hpfParams.cancel !== null && (hpfParams.cancel === 1 || hpfParams.cancel === 2 )) {
          window.top.cancelCREPayment(hpfParams.cancel, hpfParams.cancelUrl);
          document.getElementById("loadingCompleteFrame").src = hpfParams.currentLocation + "?creReserved=r";
        }
        else if (hpfParams.whatCVV2 !== null || hpfParams.whatsThis !== null) {
          window.top.whatCVV2(hpfParams.whatsThis);
          document.getElementById("loadingCompleteFrame").src = hpfParams.currentLocation + "?creReserved=r";
        }
        else if (hpfParams.processStart == "1") {
          window.top.startCREPayment();
        }
        else if (hpfParams.errorCode === null) {
          var transaction = {};
          // Taken from example callback JavaScript to build transaction object.
          var qStr = window.location.search.substring(1);
          var qStrParts = qStr.split("&");
          for (var i = 0; i < qStrParts.length; i++) {
            var qStrNV = qStrParts[i].split("=");
            transaction[qStrNV[0]] = qStrNV[1];
          }
          window.top.completeCREPayment( transaction, hpfParams.returnUrl );
          document.getElementById("loadingCompleteFrame").src = hpfParams.currentLocation + "?creReserved=r";
        }
        else {
          window.top.creHandleDetailErrors(hpfParams.errorCode, hpfParams.gatewayCode, hpfParams.gatewayMessage, hpfParams.cancelUrl);
          document.getElementById("loadingCompleteFrame").src = hpfParams.currentLocation + "?creReserved=r";
        }
      }
      // Hide the next checkout step button since the iframe has its own.
      if ($('#commerce-chase-orbital-hpf-iframe').length) {
        $('#edit-actions-next').hide();
      }
      else {
        $('#edit-actions-next').show();
      }
    },
    whatCVV2: function () {
      var string = Drupal.t('The CVV Number ("Card Verification Value") on your credit card or debit card is a 3 digit number on VISA®, MasterCard® and Discover® branded credit and debit cards. On your American Express® branded credit or debit card it is a 4 digit numeric code.');
      // @todo add Drupal.theme implementation and preprend above iframe, or something.
      alert(string);
    },
    creHandleErrors: function (errorCode) {
      console.log(errorCode);
    },
    creHandleDetailErrors: function (errorCode, gatewayCode, gatewayMessage) {
      console.log(errorCode);
      $('.completeButton').prop('disabled', true);
    },
    startCREPayment: function () {
      $('.completeButton').prop('disabled', true);
    },
    completeCREPayment: function (transaction) {
      $('.chase-card-type').val(transaction.ccType);
      $('.chase-card-number').val(transaction.ccNumber);
      $('.chase-exp-month').val(transaction.expMonth);
      $('.chase-exp-year').val(transaction.expYear);
      $('.chase-remote-id').val(this.drupalSettings.commerce_chase.remoteId);
      $('form.commerce-checkout-flow').submit();
    },
    completePayment: function () {
      $('.completeButton').prop('disabled', false);
    }
  }

})(jQuery, Drupal, window);
